library xfxbase;

import 'package:flutter/material.dart';
import 'package:syncfusion_flutter_datagrid/datagrid.dart';
import 'package:uuid/uuid.dart';

class XBandBase {
  ///  Se filatto verrà messo nel Header della band e verrà reso visibile
  String? titleBand;

  ///  Altezza delle Row, se -1 viene ignorata. default = -1.
  int? rowHeight;

  ///  Indica il numero massimo di linee a cui viene espansa una Row che contiene celle multiline che non riescono a far vedere il risultato Default:0 -> Default DsiFX
  ///  = 2 ... -> prenderà il valora da XGrid.RowSizingAutoMaxLines ((ancora da scrivere))
  ///  o da UGrid.Lay.Override.RowSizingAutoMaxLines e.Layout.Bands[0].Override.RowSizingAutoMaxLines
  int? rowSizingAutoMaxLines;

  // //  XSqlSelect sqlSelect;//TODO non c'è

  ///  Usabile per appoggiarci la Where che si vorebbe nella query. Usata per metterci
  ///  la parte Wher ein arrivo da quickFilter/situazioni In XElencoCtrl ha la prioritò
  ///  sulla where di xb.SqlSel
  String? sqlWhere;

  String? sqlWhereRowFilter;

  ///  Se true NON applica xb.SqlWhere ai dvs[i].RowFilter default: false
  bool? sqlWhereDontSetDvRowFilter;

  ///   se true non permette Update della grid ne AllowAddNew
  bool? readOnly;

  ///   Indica se è possibile aggiungere rows alla Band. Default: .AllowAddNew.Default
  ///   Viene applicata all'Ovveride della Band on this.Apply()
  bool? allowAddNew;

  bool? allowDelete;

  /// riflette caratt UltraGrid default = NotAllowed
  bool? allowColSwapping;

  ///  abilita i filtri sulle Head
  bool? filtersEnabled;

  ///  Escluderà queste colonne dalla query SQL che farà in automatco per prendere i dati
  List<dynamic>? sortedColumns;

  ///  cols che sono da mette in sola lettura, usata come listaResolved. Default: = new List<dynamic>
  List<String>? readOnlyCols;

  ///  ID che identifica la View in XBot
  Uuid? iD;

  ///  Indica se la band deve essere visibile o meno default: false
  bool? hidden;

  ///  XGrid alla quale questa band è legata (setted on XGrid.ApplyLayout() 4 now) default: null
  XGrid? xGrid;

  ///  Indice della Band Default: 0
  int index;

  ///  forza UBand.Indentation default: -1 non -> viene applicato alla UBand
  int? indentation;

  ///  Key / Nome della Band -> == XObjDef.TableNameDS
  String? key;

  String? viewKey;

  ///  Default: List<XCol>.empty(growable: true)
  List<XCol>? cols;

  ///  nomi delle colonne della Band parent i cui Header.Caption e valori verranno aggiunti al SummaryFooterCaption della Band default: null
  List<String>? summaryFooterCaptionCols;

  ///  nomi delle colonne della Band parent i cui soli valori saranno usati per compilare il SummaryFooterCaption della Band default: null
  List<String>? summaryFooterCaptionColsOnlyValue;

  ///  Viene usato come inizio del SummayFooterCaption, se "" ne viene generato uno di default: xbParent.XObjDef.DocCaption default: ""
  String? summaryFooterCaption;

  ///  Default: TRUE. mette in bold tutti i testi della SummaryArea (descrizione e valori)
  bool? summaryFooterAppearanceFontDataBold;

  ///  elenco String delle colonne abilitate all'editing, usata come listaResolved. Default: = List<String>.empty(growable:true)
  List<String>? enabledCols;

  ///  Abilita la funzionalità AutoPreview della URow della UGrid
  bool? autoPreviewEnabled;

  XBandBase(
    this.index, {
    this.titleBand,
    this.allowAddNew,
    this.allowColSwapping,
    this.allowDelete,
    this.autoPreviewEnabled,
    this.cols,
    this.enabledCols,
    this.filtersEnabled,
    this.hidden,
    this.iD,
    this.indentation,
    this.key,
    this.readOnly,
    this.readOnlyCols,
    this.rowHeight,
    this.rowSizingAutoMaxLines,
    this.sortedColumns,
    this.sqlWhere,
    this.sqlWhereDontSetDvRowFilter,
    this.sqlWhereRowFilter,
    this.summaryFooterAppearanceFontDataBold,
    this.summaryFooterCaption,
    this.summaryFooterCaptionCols,
    this.summaryFooterCaptionColsOnlyValue,
    this.viewKey,
    this.xGrid,
  });
}

class XGrid {
  ///  se true, una volta added a row, cerca via () la cella da mettere in edit ed entra in edit default: true
  bool? addRowEnterInEditAfter;

  ///  Eventuale titolo della Grid, viene usato (XSDC) per dare il Titolo all eventuale DockaBleControlPanel che lo contiene
  String? titolo;
  // //  Scrollbars _Scrollbars;????//TODO
  Color? backColor;

  ///  default: DefaultableBoolean.False
  bool? allowUpdate;

  ///  default: DefaultableBoolean.False
  bool? allowDelete;

  ///  default: AllowAddNew.No
  bool? allowAddNew;

  dynamic selectTypeRow; //SelectType

  Function(dynamic)? cellClickAction; //CellClickAction

  bool? allowRowFiltering;

  XBandBase? band0;

  ///  default: empty XBandColl() OLD>default: lentgh:3 of new XBand(i);
  List<XBandBase>? bands;

  bool? viewGroupBy;

  List<dynamic>? selectedRows;

  bool? autoFitColumns;

  dynamic gridType;

  dynamic selectTypeCol;

  bool? allowRowSummaries;

  ///  Numero di Bands massime
  int? maxBandsCount;

  bool? allowGroupSwapping;

  ColumnWidthMode? columnAutoSizeMode;

  ///  Default: AllowColSizing.Free
  bool? allowColSizing;

  bool? rowSelectors;

  Function()? selectTypeCell;

  bool? allowColSwapping;

  SfDataGrid? ug;

  bool? allowEdit;

  bool? readOnly;

  XGrid({
    this.addRowEnterInEditAfter,
    this.allowAddNew,
    this.allowColSizing,
    this.allowColSwapping,
    this.allowDelete,
    this.allowEdit,
    this.allowGroupSwapping,
    this.allowRowFiltering,
    this.allowRowSummaries,
    this.allowUpdate,
    this.backColor,
    this.autoFitColumns,
    this.band0,
    this.bands,
    this.cellClickAction,
    this.columnAutoSizeMode,
    this.gridType,
    this.maxBandsCount,
    this.readOnly,
    this.rowSelectors,
    this.selectTypeCell,
    this.selectTypeCol,
    this.selectTypeRow,
    this.selectedRows,
    this.titolo,
    this.ug,
    this.viewGroupBy,
  });
}

class XCol {
  ///  Key che identifica la Colonna
  String? key;

  ///  AutoFilled dal framework quando viene applicata ad una UCol
  Type? dataType;

  ///  Viene Istanziata la XCol, ma rimane nascosta.
  bool? hidden;

  ///  _OldStyle_DontUse_ Valori OriX, OriY, SpanX, SpanY (meglio se multipli di 2)
  List<int>? rowLayoutPos;

  ///  Icona da mettere sulla Label della colonna/cella
  dynamic headerIcon;

  bool? readOnly;

  bool? isSelfDropDown;

  String? toolTip;

  ///  Indica che la XCol non è presente della DataTable dell'attore Default: false
  bool? isUnBound;

  ///  Se true viene aggiunta a xb.Summaries in fase di init della XBand)
  bool? summarize;

  TextAlignVertical? txtVAlign;
  //  EditorControlStyle editorStyle; //TODO non c'è
  bool? isImage;

  ///  Column/Cell Label
  String? label;

  ///  Se impostato viene applicato alla appareance della LABEL della CELLA
  TextAlign? labelTxtHAlign;

  ///  Visibile Position: quando NON si usa RowLayout indica la posizione, partendo da sx, della colonna nella riga
  int? visPos;

  ///  Larghezza della Colonna/Cella, non impositiva
  int? width;

  ///  Allineamento orrizontale del testo Default: HAlign.Default
  TextAlign? txtHAlign;

  ///  Livello della cella/colonna: quando NON si usa RowLayout indica a su quale riga della Row viene posizionata la cella
  int? level;

  ///  Lunghezza massima dei dati nel campo. Definita in XGrid.SetLenOfDataEntryOnDataType(...)
  int? maxFldLen;

  ///  Altezza della cella
  int? height;

  ///  Se si vuole che se il testo contenuto se esce dalla larghezza della cella aumenti l'altezza per n righe al max come specificato in ...maxRow... nell Override della grid/band
  bool? cellMultiLine;

  ///  Formato di visualizzazione del valore (Es: )
  String? format;

  ///  Formula da usare in UltraCalcManager
  String? formula;

  bool? useValue;

  bool? displayOnly;

  ///  Può contenere un object che definisca un DropDown che andrà usato per la UCol:
  ///     - XDropDown: viene usato in AssignDropDown - Infragistics.Win.ValueList in Apply()
  ///     - UltraDropDown in Apply()
  dynamic dropDown;

  XCol({
    this.cellMultiLine,
    this.dataType,
    this.displayOnly,
    this.dropDown,
    this.format,
    this.formula,
    this.headerIcon,
    this.height,
    this.hidden,
    this.isImage,
    this.isSelfDropDown,
    this.isUnBound,
    this.key,
    this.label,
    this.labelTxtHAlign,
    this.level,
    this.maxFldLen,
    this.readOnly,
    this.rowLayoutPos,
    this.summarize,
    this.toolTip,
    this.txtHAlign,
    this.txtVAlign,
    this.useValue,
    this.visPos,
    this.width,
  });
}
